import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _initializerDefineProperty from "@babel/runtime/helpers/initializerDefineProperty";
import _applyDecoratedDescriptor from "@babel/runtime/helpers/applyDecoratedDescriptor";
import _initializerWarningHelper from "@babel/runtime/helpers/initializerWarningHelper";

var _dec, _dec2, _class, _class2, _descriptor;

import _regeneratorRuntime from "@babel/runtime/regenerator";
import { CanvasConfig } from '@antv/g';
import { inject, injectable } from 'inversify';
import { isString } from '@antv/util';
import { createSVGElement } from './utils/dom';
export var SVGContextService = (_dec = injectable(), _dec2 = inject(CanvasConfig), _dec(_class = (_class2 = /*#__PURE__*/function () {
  function SVGContextService() {
    this.$container = void 0;
    this.$namespace = void 0;
    this.dpr = void 0;

    _initializerDefineProperty(this, "canvasConfig", _descriptor, this);
  }

  var _proto = SVGContextService.prototype;

  _proto.init = function init() {
    var container = this.canvasConfig.container; // create container

    this.$container = isString(container) ? document.getElementById(container) : container;

    if (this.$container) {
      var $namespace = createSVGElement('svg');
      $namespace.setAttribute('width', "" + this.canvasConfig.width);
      $namespace.setAttribute('height', "" + this.canvasConfig.height);
      this.$container.appendChild($namespace);
      this.$namespace = $namespace;
    }

    var dpr = window.devicePixelRatio || 1;
    dpr = dpr >= 1 ? Math.ceil(dpr) : 1;
    this.dpr = dpr;
  };

  _proto.getDomElement = function getDomElement() {
    return this.$namespace;
  };

  _proto.getContext = function getContext() {
    return this.$namespace;
  };

  _proto.getDPR = function getDPR() {
    return this.dpr;
  };

  _proto.getBoundingClientRect = function getBoundingClientRect() {
    var _this$$namespace;

    return (_this$$namespace = this.$namespace) === null || _this$$namespace === void 0 ? void 0 : _this$$namespace.getBoundingClientRect();
  };

  _proto.destroy = /*#__PURE__*/function () {
    var _destroy = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              // destroy context
              if (this.$container && this.$namespace) {
                this.$container.removeChild(this.$namespace);
              }

            case 1:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    function destroy() {
      return _destroy.apply(this, arguments);
    }

    return destroy;
  }();

  _proto.resize = function resize(width, height) {
    if (this.$namespace) {
      this.$namespace.setAttribute('width', "" + width);
      this.$namespace.setAttribute('height', "" + height);
    }
  };

  _proto.applyCursorStyle = function applyCursorStyle(cursor) {
    if (this.$container) {
      this.$container.style.cursor = cursor;
    }
  };

  return SVGContextService;
}(), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "canvasConfig", [_dec2], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: null
})), _class2)) || _class);
//# sourceMappingURL=SVGContextService.js.map