var _dec, _class;

import { isString } from '@antv/util';
import { injectable } from 'inversify';
export var ImageRenderer = (_dec = injectable(), _dec(_class = /*#__PURE__*/function () {
  function ImageRenderer() {}

  var _proto = ImageRenderer.prototype;

  _proto.apply = function apply($el, attributes) {
    var img = attributes.img,
        _attributes$width = attributes.width,
        width = _attributes$width === void 0 ? 0 : _attributes$width,
        _attributes$height = attributes.height,
        height = _attributes$height === void 0 ? 0 : _attributes$height,
        _attributes$anchor = attributes.anchor,
        anchor = _attributes$anchor === void 0 ? [0, 0] : _attributes$anchor; // set anchor

    $el.setAttribute('x', "" + -anchor[0] * width);
    $el.setAttribute('y', "" + -anchor[1] * height);

    if (isString(img)) {
      $el.setAttribute('href', img);
    } else if (img instanceof Image) {
      if (!width) {
        $el.setAttribute('width', "" + img.width); // TODO: set renderable.aabbDirty
        // this.attr('width', img.width);
      }

      if (!height) {
        $el.setAttribute('height', "" + img.height); // this.attr('height', img.height);
      }

      $el.setAttribute('href', img.src);
    } else if (img instanceof HTMLElement && isString(img.nodeName) && img.nodeName.toUpperCase() === 'CANVAS') {
      $el.setAttribute('href', img.toDataURL());
    } else if (img instanceof ImageData) {
      var canvas = document.createElement('canvas');
      canvas.setAttribute('width', "" + img.width);
      canvas.setAttribute('height', "" + img.height);
      var context = canvas.getContext('2d');

      if (context) {
        context.putImageData(img, 0, 0);

        if (!width) {
          $el.setAttribute('width', "" + img.width); // this.attr('width', img.width);
        }

        if (!height) {
          $el.setAttribute('height', "" + img.height); // this.attr('height', img.height);
        }

        $el.setAttribute('href', canvas.toDataURL());
      }
    }
  };

  return ImageRenderer;
}()) || _class);
//# sourceMappingURL=Image.js.map