var _dec, _class;

import { isArray } from '@antv/util';
import { parseRadius } from '../../utils/format';
import { injectable } from 'inversify';
export var RectRenderer = (_dec = injectable(), _dec(_class = /*#__PURE__*/function () {
  function RectRenderer() {}

  var _proto = RectRenderer.prototype;

  _proto.apply = function apply($el, attributes) {
    var _attributes$radius = attributes.radius,
        radius = _attributes$radius === void 0 ? 0 : _attributes$radius,
        _attributes$width = attributes.width,
        width = _attributes$width === void 0 ? 0 : _attributes$width,
        _attributes$height = attributes.height,
        height = _attributes$height === void 0 ? 0 : _attributes$height;
    var d = '';

    if (!radius) {
      d = "M 0, 0 l " + width + ",0 l 0," + height + " l" + -width + " 0 z";
    } else {
      var r = parseRadius(radius);

      if (isArray(radius)) {
        if (radius.length === 1) {
          r.r1 = r.r2 = r.r3 = r.r4 = radius[0];
        } else if (radius.length === 2) {
          r.r1 = r.r3 = radius[0];
          r.r2 = r.r4 = radius[1];
        } else if (radius.length === 3) {
          r.r1 = radius[0];
          r.r2 = r.r4 = radius[1];
          r.r3 = radius[2];
        } else {
          r.r1 = radius[0];
          r.r2 = radius[1];
          r.r3 = radius[2];
          r.r4 = radius[3];
        }
      } else {
        r.r1 = r.r2 = r.r3 = r.r4 = radius;
      }

      d = [["M " + r.r1 + ",0"], ["l " + (width - r.r1 - r.r2) + ",0"], ["a " + r.r2 + "," + r.r2 + ",0,0,1," + r.r2 + "," + r.r2], ["l 0," + (height - r.r2 - r.r3)], ["a " + r.r3 + "," + r.r3 + ",0,0,1," + -r.r3 + "," + r.r3], ["l " + (r.r3 + r.r4 - width) + ",0"], ["a " + r.r4 + "," + r.r4 + ",0,0,1," + -r.r4 + "," + -r.r4], ["l 0," + (r.r4 + r.r1 - height)], ["a " + r.r1 + "," + r.r1 + ",0,0,1," + r.r1 + "," + -r.r1], ['z']].join(' ');
    }

    $el.setAttribute('d', d);
  };

  return RectRenderer;
}()) || _class);
//# sourceMappingURL=Rect.js.map