"use strict";
exports.__esModule = true;
exports.containerModule = exports.ElementSVG = void 0;
var inversify_1 = require("inversify");
var g_1 = require("@antv/g");
var ElementSVG_1 = require("./components/ElementSVG");
exports.ElementSVG = ElementSVG_1.ElementSVG;
var paths_1 = require("./shapes/paths");
var SVGRendererPlugin_1 = require("./SVGRendererPlugin");
g_1.world.registerComponent(ElementSVG_1.ElementSVG);
exports.containerModule = new inversify_1.ContainerModule(function (bind, unbind, isBound, rebind) {
    /**
     * register shape renderers
     */
    bind(paths_1.RectRenderer).toSelf().inSingletonScope();
    bind(paths_1.ImageRenderer).toSelf().inSingletonScope();
    bind(paths_1.LineRenderer).toSelf().inSingletonScope();
    bind(paths_1.PolylineRenderer).toSelf().inSingletonScope();
    bind(paths_1.TextRenderer).toSelf().inSingletonScope();
    bind(paths_1.ElementRendererFactory).toFactory(function (ctx) { return function (tagName) {
        if (tagName === g_1.SHAPE.Rect) {
            return ctx.container.get(paths_1.RectRenderer);
        }
        else if (tagName === g_1.SHAPE.Image) {
            return ctx.container.get(paths_1.ImageRenderer);
        }
        else if (tagName === g_1.SHAPE.Line) {
            return ctx.container.get(paths_1.LineRenderer);
        }
        else if (tagName === g_1.SHAPE.Polyline || tagName === g_1.SHAPE.Polygon) {
            return ctx.container.get(paths_1.PolylineRenderer);
        }
        else if (tagName === g_1.SHAPE.Text) {
            return ctx.container.get(paths_1.TextRenderer);
        }
        return null;
    }; });
    bind(SVGRendererPlugin_1.SVGRendererPlugin).toSelf().inSingletonScope();
    bind(g_1.RenderingPluginContribution).toService(SVGRendererPlugin_1.SVGRendererPlugin);
});
