"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
exports.__esModule = true;
exports.ImageRenderer = void 0;
var util_1 = require("@antv/util");
var inversify_1 = require("inversify");
var ImageRenderer = /** @class */ (function () {
    function ImageRenderer() {
    }
    ImageRenderer.prototype.apply = function ($el, attributes) {
        var img = attributes.img, _a = attributes.width, width = _a === void 0 ? 0 : _a, _b = attributes.height, height = _b === void 0 ? 0 : _b, _c = attributes.anchor, anchor = _c === void 0 ? [0, 0] : _c;
        // set anchor
        $el.setAttribute('x', "" + -anchor[0] * width);
        $el.setAttribute('y', "" + -anchor[1] * height);
        if (util_1.isString(img)) {
            $el.setAttribute('href', img);
        }
        else if (img instanceof Image) {
            if (!width) {
                $el.setAttribute('width', "" + img.width);
                // TODO: set renderable.aabbDirty
                // this.attr('width', img.width);
            }
            if (!height) {
                $el.setAttribute('height', "" + img.height);
                // this.attr('height', img.height);
            }
            $el.setAttribute('href', img.src);
        }
        else if (img instanceof HTMLElement && util_1.isString(img.nodeName) && img.nodeName.toUpperCase() === 'CANVAS') {
            $el.setAttribute('href', img.toDataURL());
        }
        else if (img instanceof ImageData) {
            var canvas = document.createElement('canvas');
            canvas.setAttribute('width', "" + img.width);
            canvas.setAttribute('height', "" + img.height);
            var context = canvas.getContext('2d');
            if (context) {
                context.putImageData(img, 0, 0);
                if (!width) {
                    $el.setAttribute('width', "" + img.width);
                    // this.attr('width', img.width);
                }
                if (!height) {
                    $el.setAttribute('height', "" + img.height);
                    // this.attr('height', img.height);
                }
                $el.setAttribute('href', canvas.toDataURL());
            }
        }
    };
    ImageRenderer = __decorate([
        inversify_1.injectable()
    ], ImageRenderer);
    return ImageRenderer;
}());
exports.ImageRenderer = ImageRenderer;
