"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
exports.__esModule = true;
exports.RectRenderer = void 0;
var util_1 = require("@antv/util");
var format_1 = require("../../utils/format");
var inversify_1 = require("inversify");
var RectRenderer = /** @class */ (function () {
    function RectRenderer() {
    }
    RectRenderer.prototype.apply = function ($el, attributes) {
        var _a = attributes.radius, radius = _a === void 0 ? 0 : _a, _b = attributes.width, width = _b === void 0 ? 0 : _b, _c = attributes.height, height = _c === void 0 ? 0 : _c;
        var d = '';
        if (!radius) {
            d = "M 0, 0 l " + width + ",0 l 0," + height + " l" + -width + " 0 z";
        }
        else {
            var r = format_1.parseRadius(radius);
            if (util_1.isArray(radius)) {
                if (radius.length === 1) {
                    r.r1 = r.r2 = r.r3 = r.r4 = radius[0];
                }
                else if (radius.length === 2) {
                    r.r1 = r.r3 = radius[0];
                    r.r2 = r.r4 = radius[1];
                }
                else if (radius.length === 3) {
                    r.r1 = radius[0];
                    r.r2 = r.r4 = radius[1];
                    r.r3 = radius[2];
                }
                else {
                    r.r1 = radius[0];
                    r.r2 = radius[1];
                    r.r3 = radius[2];
                    r.r4 = radius[3];
                }
            }
            else {
                r.r1 = r.r2 = r.r3 = r.r4 = radius;
            }
            d = [
                ["M " + r.r1 + ",0"],
                ["l " + (width - r.r1 - r.r2) + ",0"],
                ["a " + r.r2 + "," + r.r2 + ",0,0,1," + r.r2 + "," + r.r2],
                ["l 0," + (height - r.r2 - r.r3)],
                ["a " + r.r3 + "," + r.r3 + ",0,0,1," + -r.r3 + "," + r.r3],
                ["l " + (r.r3 + r.r4 - width) + ",0"],
                ["a " + r.r4 + "," + r.r4 + ",0,0,1," + -r.r4 + "," + -r.r4],
                ["l 0," + (r.r4 + r.r1 - height)],
                ["a " + r.r1 + "," + r.r1 + ",0,0,1," + r.r1 + "," + -r.r1],
                ['z'],
            ].join(' ');
        }
        $el.setAttribute('d', d);
    };
    RectRenderer = __decorate([
        inversify_1.injectable()
    ], RectRenderer);
    return RectRenderer;
}());
exports.RectRenderer = RectRenderer;
